/*
	T2 Binyuu Hunter
	for LSI-C(86)
*/
#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>

void main( int ac, char **av )
{
	FILE			*in;
	FILE			*out;
	unsigned char	*buf;
	unsigned char	*filebuf;
	unsigned long	file_ed = 0;
	unsigned int	file_count;
	unsigned long	header_filest = 0;
	unsigned long	header_fileed = 0;
	unsigned long	header_filesize = 0;
	char			header_filename[13];
	char			out_filename[256];
	unsigned long	nowsize;

	int				i = 0;

	printf( "T2 Binyuu Hunter File Divider 130320 (c)KUROHANE Works\n" );

	if( ac == 1 )
	{
		printf( "usage: BNHDIV <filename> <dest_dir>\n" );
		return;
	}

	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}

	printf( "filename: %s\n", av[1] );

	/* filesize */
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );
	printf( "file_size: %lu bytes\n", file_ed );

	/* header */
	buf = ( unsigned char * )calloc( 1, 0x04 );
	fseek( in, 0, SEEK_SET );
	fread( buf, 0x04, 1, in );
	free( buf );

	/* file_count */
	file_count = *( unsigned long * )( buf ) / 4;
	printf( "file_count: %u\n", file_count );

	/* read header */
	header_filesize = ( file_count * 4 );
	buf = ( unsigned char * )calloc( 1, header_filesize );
	fseek( in, 0, SEEK_SET );
	fread( buf, header_filesize, 1, in );

	printf( "\n" );

	for( i = 0; i < ( file_count - 1 ); i++ )
	{
		sprintf( header_filename, "%02X.BIN", i );
		header_filest = *( unsigned long *)( buf + ( i * 4 ));
		header_fileed = *( unsigned long *)( buf + (( i * 4 ) + 4 ));
		header_filesize = header_fileed - header_filest;

		if( header_filesize == 0 ) continue;

		printf( "%04d : %-12s %08lX-%08lX (%lu) ",
			i + 1,
			header_filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		if( ac == 3 )
		{
			sprintf( out_filename, "%s%s",
				av[2],
				header_filename
			);
		} else sprintf( out_filename, "%s", header_filename );

		out = fopen( out_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		fseek( in, header_filest, SEEK_SET );

		filebuf = ( unsigned char * )calloc( 1, 32768 );
		nowsize = header_filesize;

		while( !( nowsize < 32769 ))
		{
			fread( filebuf, 32768, 1, in );
			fwrite( filebuf, 32768, 1, out );
			nowsize -= 32768;
			printf( "." );
		}
		fread( filebuf, nowsize, 1, in );
		fwrite( filebuf, nowsize, 1, out );

		free( filebuf );

		fclose( out );
		printf( ".\n" );
	}

	printf( "\n" );
	printf( "complete.\n" );
end:;
	free( buf );
	fclose( in );

	return;
}
